#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Fileversion=0.0.0.2
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include "CUIAutomation2.au3"
#include "UIAWrappers.au3"
#include<file.au3>
#include <IE.au3>
#include <ClipBoard.au3>

If StringInStr(@OSArch, "64") > 0 And @AutoItX64 = 0 Then
	MsgBox(16, "IEAE", "x64 OS + x86 executable = naughty"&@LF&@LF&"Use the x64 version of IEAE.")
	Exit
EndIf

$sInifile = StringLeft(@ScriptFullPath, StringLen(@ScriptFullPath) - 4) & '.ini'
If Not FileExists($sInifile) Then
	MsgBox(16, "IEAE", "Missing config file:"&@LF&@LF&$sInifile)
	Exit
EndIf
Global $SmtpServer = IniRead($sInifile, "SMTP", "SmtpServer", "") ; address for the smtp-server to use - REQUIRED
Global $FromName = IniRead($sInifile, "SMTP", "FromName", "") ; name from who the email was sent
Global $FromAddress = IniRead($sInifile, "SMTP", "FromAddress", "") ; address from where the mail should come
Global $ToAddress = IniRead($sInifile, "SMTP", "ToAddress", "") ; destination address of the email - REQUIRED
Global $Subject = IniRead($sInifile, "SMTP", "Subject", "") ; subject from the email - can be anything you want it to be
Global $Body = IniRead($sInifile, "SMTP", "Body", "") ; the messagebody from the mail - can be left blank but then you get a blank mail
Global $Username = IniRead($sInifile, "SMTP", "Username", "") ; username for the account used from where the mail gets sent - REQUIRED
Global $Password = IniRead($sInifile, "SMTP", "Password", "") ; password for the account used from where the mail gets sent - REQUIRED
Global $IPPort = IniRead($sInifile, "SMTP", "Port", 25) ; port used for sending the mail
Global $ssl = IniRead($sInifile, "SMTP", "SSL", 0) ; enables/disables secure socket layer sending - put to 1 if using httpS

Global $oMyRet[2]
Global $oMyError = ObjEvent("AutoIt.Error", "MyErrFunc")

_UIA_Init()

If $Cmdline[0] = 0 Then
	$sType = "I"
Else
	$sType = StringUpper(StringLeft($Cmdline[1], 1))
EndIf

Switch $sType
	Case "I"
		$wTitle = WinGetTitle("[CLASS:IEFrame]")
		If IsNumber($wTitle) Then Exit
		$wURL = ControlGetText("[CLASS:IEFrame]", "", "Edit1")
		If $wURL = "" Then Exit
	Case "F"
		$oFF = _UIA_getFirstObjectOfElement($oDesktop, "class:=MozillaWindowClass", $TreeScope_Children)

		If IsObj($oFF) Then
			$wTitle = _UIA_getPropertyValue($oFF, $UIA_NamePropertyId)
			WinActivate($wTitle)
			Send("^l")
			Send("^c")
			$wURL = _ClipBoard_GetData($CF_TEXT)
		EndIf
	Case Else
		Exit
EndSwitch

$Subject = StringLeft(StringStripWS($Subject & " " & $wTitle, 3), 70) & "..."
$Body = StringStripWS($Body & @CRLF & @CRLF & $wURL, 1)

$rc = _INetSmtpMailCom($SmtpServer, $FromName, $FromAddress, $ToAddress, $Subject, $Body, "", "", "", "Normal", $Username, $Password, $IPPort, $ssl)
If @error Then
	MsgBox(0, "Error sending message", "Error code:" & @error & "  Description:" & $rc)
EndIf

Func _INetSmtpMailCom($s_SmtpServer, $s_FromName, $s_FromAddress, $s_ToAddress, $s_Subject = "", $as_Body = "", $s_AttachFiles = "", $s_CcAddress = "", $s_BccAddress = "", $s_Importance = "Normal", $s_Username = "", $s_Password = "", $IPPort = 25, $ssl = 0)
	Local $objEmail = ObjCreate("CDO.Message")
	$objEmail.From = '"' & $s_FromName & '" <' & $s_FromAddress & '>'
	$objEmail.To = $s_ToAddress
	Local $i_Error = 0
	Local $i_Error_desciption = ""
	If $s_CcAddress <> "" Then $objEmail.Cc = $s_CcAddress
	If $s_BccAddress <> "" Then $objEmail.Bcc = $s_BccAddress
	$objEmail.Subject = $s_Subject
	If StringInStr($as_Body, "<") And StringInStr($as_Body, ">") Then
		$objEmail.HTMLBody = $as_Body
	Else
		$objEmail.Textbody = $as_Body & @CRLF
	EndIf
	If $s_AttachFiles <> "" Then
		Local $S_Files2Attach = StringSplit($s_AttachFiles, ";")
		For $x = 1 To $S_Files2Attach[0]
			$S_Files2Attach[$x] = _PathFull($S_Files2Attach[$x])
			If FileExists($S_Files2Attach[$x]) Then
				ConsoleWrite('+> File attachment added: ' & $S_Files2Attach[$x] & @LF)
				$objEmail.AddAttachment($S_Files2Attach[$x])
			Else
				ConsoleWrite('!> File not found to attach: ' & $S_Files2Attach[$x] & @LF)
				SetError(1)
				Return 0
			EndIf
		Next
	EndIf
	$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2
	$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = $s_SmtpServer
	If Number($IPPort) = 0 Then $IPPort = 25
	$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = $IPPort
	;Authenticated SMTP
	If $s_Username <> "" Then
		$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
		$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendusername") = $s_Username
		$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendpassword") = $s_Password
	EndIf
	If $ssl Then
		$objEmail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpusessl") = True
	EndIf
	;Update settings
	$objEmail.Configuration.Fields.Update
	; Set Email Importance
	Switch $s_Importance
		Case "High"
			$objEmail.Fields.Item("urn:schemas:mailheader:Importance") = "High"
		Case "Normal"
			$objEmail.Fields.Item("urn:schemas:mailheader:Importance") = "Normal"
		Case "Low"
			$objEmail.Fields.Item("urn:schemas:mailheader:Importance") = "Low"
	EndSwitch
	$objEmail.Fields.Update
	; Sent the Message
	$objEmail.Send
	If @error Then
		SetError(2)
		Return $oMyRet[1]
	EndIf
	$objEmail = ""
EndFunc   ;==>_INetSmtpMailCom
;
;
; Com Error Handler
Func MyErrFunc()
	$HexNumber = Hex($oMyError.number, 8)
	$oMyRet[0] = $HexNumber
	$oMyRet[1] = StringStripWS($oMyError.description, 3)
	ConsoleWrite("### COM Error !  Number: " & $HexNumber & "   ScriptLine: " & $oMyError.scriptline & "   Description:" & $oMyRet[1] & @LF)
	SetError(1); something to check for when this function returns
	Return
EndFunc   ;==>MyErrFunc